<template>
  <div id="app">
    <main-header></main-header>

    <transition name="page" mode="out-in">
      <router-view />
    </transition>

    <install-btn :deferred-prompt="deferredPrompt"></install-btn>

    <main-footer></main-footer>
  </div>
</template>

<script>
import MainHeader from "./components/MainHeader.vue";
import MainFooter from "./components/MainFooter.vue";

import InstallBtn from "./components/InstallBtn.vue";

import { apiCustomerGet } from "./services/baseApi.js";

export default {
  components: {
    MainHeader,
    MainFooter,
    InstallBtn
  },
  data() {
    return {
      intervalID: -1,
      deferredPrompt: null
    };
  },
  watch: {
    // chuyen trang se goi
    $route() {
      this.checkUser();
    }
  },
  methods: {
    async checkUser() {
      this.intervalID = setInterval(() => {
        let user = localStorage.getItem("user");
        let token = localStorage.getItem("token");

        if (!user && token) {
          this.getUser();
        } else {
          clearInterval(this.intervalID);
        }
      }, 1000);
    },
    async getUser() {
      try {
        let token = localStorage.getItem("token");

        if (!token) {
          return;
        }

        let res = await apiCustomerGet("auth/profile", {}, { token });
        if (res && res.data && res.data.status && res.data.data) {
          res.data.data.isLogged = true;

          //Save data
          localStorage.setItem("user", JSON.stringify(res.data.data));
          this.$store.commit("setUser", res.data.data);
        }
      } catch (error) {
        console.log(error);
      }
    }
  },
  mounted() {
    this.getUser();

    // Init FB SDK
    //
    //
    const FB_APP_ID = "801883857082297"; // product
    // const FB_APP_ID = "163996518780947"; // test

    window.fbAsyncInit = function() {
      window.FB.init({
        appId: FB_APP_ID,
        autoLogAppEvents: true,
        xfbml: true,
        version: "v10.0"
      });
    };
    (function(d, s, id) {
      var js,
        fjs = d.getElementsByTagName(s)[0];
      if (d.getElementById(id)) {
        return;
      }
      js = d.createElement(s);
      js.id = id;
      js.src = "https://connect.facebook.net/en_US/sdk.js";
      fjs.parentNode.insertBefore(js, fjs);
    })(document, "script", "facebook-jssdk");
    //
    //
    // Init FB SDK

    // BTC, BSBT to USD price
    //
    //
    const callServiceBsbt = async () => {
      try {
        let res = await apiCustomerGet("price");
        if (res && res.data && res.data.data && res.data.data.price && res.data.data.price.result) {
          let price = res.data.data.price.result.last || 0;

          localStorage.setItem("bsbt-price", Number(price));
        }
      } catch (error) {
        console.log(error);
      }
    };
    const callServiceBtc = async () => {
      try {
        let res = await apiCustomerGet("dashboard/btc/price");
        if (res && res.data && res.data.data) {
          localStorage.setItem("btc-price", res.data.data.price);
        }
      } catch (error) {
        console.log(error);
      }
    };
    callServiceBsbt();
    callServiceBtc();
    //
    //
    // BTC, BSBT to USD price

    // Show install prompt
    //
    //
    const buttonInstall = document.getElementById("install-btn");

    // Initialize deferredPrompt for use later to show browser install prompt.
    window.addEventListener("beforeinstallprompt", (e) => {
      // Prevent the mini-infobar from appearing on mobile
      e.preventDefault();
      // Stash the event so it can be triggered later.
      this.deferredPrompt = e;
      // Update UI notify the user they can install the PWA
      // showInstallPromotion();
      // Optionally, send analytics event that PWA install promo was shown.
      console.log(`'beforeinstallprompt' event was fired.`);
    });

    buttonInstall.addEventListener("click", async () => {
      // Hide the app provided install promotion
      // hideInstallPromotion();
      // Show the install prompt
      this.deferredPrompt.prompt();
      // Wait for the user to respond to the prompt
      const { outcome } = await this.deferredPrompt.userChoice;
      // Optionally, send analytics event with outcome of user choice
      console.log(`User response to the install prompt: ${outcome}`);
      // We've used the prompt, and can't use it again, throw it away
      this.deferredPrompt = null;
    });

    window.addEventListener("appinstalled", () => {
      // Hide the app-provided install promotion
      // hideInstallPromotion();
      // Clear the deferredPrompt so it can be garbage collected
      this.deferredPrompt = null;
      // Optionally, send analytics event to indicate successful install
      console.log("PWA was installed");
    });
    //
    //
    // Show install prompt
  }
};
</script>

<style>
@import "./assets/styles/style.css";
@import "./assets/styles/custom.css";
@import "./assets/styles/custom2.css";
@import "./assets/font/style.css";
@import "./assets/styles/custom-media-query.css";

.page-enter-active,
.page-leave-active {
  transition: opacity 0.4s, transform 0.4s;
}
.page-enter,
.page-leave-to {
  opacity: 0;
  transform: translateX(-3%);
}
.goog-te-menu-frame {
  box-shadow: 2px 3px 8px 0px #99999999 !important;
}

</style>
